<template>
  <div class="page-body">

    <vxe-form :data="formOptions.data" ref="xForm" :title-width="formOptions.titleWidth"
      :title-align="formOptions.titleAlign" :rules="formOptions.rules" :items="formOptions.items" titleColon>
      <template #myregion="{}">
        <a-input-search placeholder="input search text" enter-button />
      </template>
    </vxe-form>


    <div>
      <a-button type="primary" @click="ok">确定</a-button>
      <a-button @click="cancel">取消</a-button>
    </div>

  </div>
</template>

<script>
import BASE_URL from '@/services/base/api.js';

export default {
  name: 'BasePermissionEdit',

  props: {
    pageMode: {
      type: String,
      default: "edit"
    },
    dataId: {
    }

  },

  data() {

    // 页面数据变量
    var pageData = {

      actions: {
        create: `${BASE_URL.BASE_URL}/BasePermission/v1/base/permission/create`,
        update: `${BASE_URL.BASE_URL}/BasePermission/v1/base/permission/update`,
        get: `${BASE_URL.BASE_URL}/BasePermission/v1/base/permission/detail`
      },

      formOptions: {
        data: {
          "title": "",
          "service": "",
          "permission_code": "",
          "desc": ""
        },

        titleWidth: 100,
        titleAlign: 'right',

        rules: {
          title: [
            { required: true, message: '请输入权限名' }
          ] 
        },

        items: [
          {
            title: '左侧',
            children: [
              { field: 'title', title: '权限名', span: 24, itemRender: { name: '$input', props: { placeholder: '请输入权限名' } } },
              { field: 'permission_code', title: '编号', span: 24, itemRender: { name: '$input', props: { placeholder: '请输入编号' } } },
              { field: 'service', title: 'service', span: 24, itemRender: { name: '$input', props: { placeholder: '请输入service' } } },
              { field: 'desc', title: '描述', span: 24, itemRender: { name: '$input', props: { placeholder: '请输入描述' } } }
            ]
          }
        ]
      }

    };

    pageData.formOptions = Object.assign(this.$mk.config.defaults.formOptions, pageData.formOptions);

    return pageData;
  },
  created() {
    if (this.dataId) {
      this.$mk.post({
        url: this.actions.get,
        loading: "加载中...",
        data: {
          id: this.dataId
        }
      }).then(a => {
        this.formOptions.data = a.data.base_permission;
      }).catch((a) => {
        this.$mk.error(a.data.msg);
      });
    }

  },
  // 函数
  methods: {


    loadData() {
    },

    ok() {

      let save = () => {
        let action = this.pageMode == "add" ? this.actions.create : this.actions.update;
        let postdata = this.pageMode == "add" ? Object.assign({ id: this.dataId }, this.formOptions.data) : Object.assign({}, this.formOptions.data);
 
        this.$mk.post({
          url: action,
          loading: "保存中...",
          data: postdata
        }).then(() => {
          this.$mk.success("保存成功");
          this.$emit("callback", { success: true });
        }).catch((a) => {
          this.$mk.error(a.data.msg);
        });
      };

      this.$refs.xForm.validate((a) => {

        if (a) {
          let count = 0;
          for (let name in a) {
            a[name];
            count++;
          }
          this.$mk.error(`存在${count}项错误，请检查`);
        } else {
          save();
        }
      });


    },

    cancel() {
      this.$emit("callback", {});
    }
  },
  // 监听属性
  watch: {

  }
};

</script>
<style scoped lang="less">

</style>
